//
// Activity.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Activity: Codable, Hashable {

    public enum Status: String, Codable, CaseIterable {
        case expected = "expected"
        case planned = "planned"
        case finished = "finished"
        case cancelled = "cancelled"
    }
    public enum Ownership: String, Codable, CaseIterable {
        case currentuser = "currentUser"
        case otheruser = "otherUser"
    }
    public var practitioner: ActivityPractitioner?
    public var location: ActivityLocation?
    /** scheduledString from https://www.nspop.dk/display/public/web/GCP+-+Guide+til+anvendere */
    public var scheduledString: String?
    public var plannedTime: ActivityPlannedTime?
    public var status: Status
    public var ownership: Ownership?
    public var title: String
    public var description: String?
    /** A pointer to whatever object this activity is related to */
    public var reference: String?
    public var code: Code?
    public var kind: String?
    public var id: String?
    /** A unique pointer to the careplan document from which this appointment origins */
    public var careplanId: String?
    public var note: Note?
    public var observations: [Observation]?
    /** Since activities may or may not have an actual plannedTime on them, this field is a computed date based on either plannedTime or (gestationAge + date of last period on the data-card if that exists (if it does not we just use today as the start point)) */
    public var sortDate: Date?

    public init(practitioner: ActivityPractitioner? = nil, location: ActivityLocation? = nil, scheduledString: String? = nil, plannedTime: ActivityPlannedTime? = nil, status: Status, ownership: Ownership? = nil, title: String, description: String? = nil, reference: String? = nil, code: Code? = nil, kind: String? = nil, id: String? = nil, careplanId: String? = nil, note: Note? = nil, observations: [Observation]? = nil, sortDate: Date? = nil) {
        self.practitioner = practitioner
        self.location = location
        self.scheduledString = scheduledString
        self.plannedTime = plannedTime
        self.status = status
        self.ownership = ownership
        self.title = title
        self.description = description
        self.reference = reference
        self.code = code
        self.kind = kind
        self.id = id
        self.careplanId = careplanId
        self.note = note
        self.observations = observations
        self.sortDate = sortDate
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case practitioner
        case location
        case scheduledString
        case plannedTime
        case status
        case ownership
        case title
        case description
        case reference
        case code
        case kind
        case id
        case careplanId
        case note
        case observations
        case sortDate
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(practitioner, forKey: .practitioner)
        try container.encodeIfPresent(location, forKey: .location)
        try container.encodeIfPresent(scheduledString, forKey: .scheduledString)
        try container.encodeIfPresent(plannedTime, forKey: .plannedTime)
        try container.encode(status, forKey: .status)
        try container.encodeIfPresent(ownership, forKey: .ownership)
        try container.encode(title, forKey: .title)
        try container.encodeIfPresent(description, forKey: .description)
        try container.encodeIfPresent(reference, forKey: .reference)
        try container.encodeIfPresent(code, forKey: .code)
        try container.encodeIfPresent(kind, forKey: .kind)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(careplanId, forKey: .careplanId)
        try container.encodeIfPresent(note, forKey: .note)
        try container.encodeIfPresent(observations, forKey: .observations)
        try container.encodeIfPresent(sortDate, forKey: .sortDate)
    }
}

