//
// CarePlan.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct CarePlan: Codable, Hashable {

    public enum DocumentStatus: String, Codable, CaseIterable {
        case new = "NEW"
        case active = "ACTIVE"
        case closed = "CLOSED"
        case partial = "PARTIAL"
    }
    public var patient: String
    public var activities: [Activity]?
    /** A reference to any external clinical pathway that this care plan is a part of */
    public var processId: String?
    public var title: String
    public var description: String?
    public var responsibleOrganization: CarePlanResponsibleOrganization
    public var id: String?
    public var version: Double?
    public var documentStatus: DocumentStatus?

    public init(patient: String, activities: [Activity]? = nil, processId: String? = nil, title: String, description: String? = nil, responsibleOrganization: CarePlanResponsibleOrganization, id: String? = nil, version: Double? = nil, documentStatus: DocumentStatus? = nil) {
        self.patient = patient
        self.activities = activities
        self.processId = processId
        self.title = title
        self.description = description
        self.responsibleOrganization = responsibleOrganization
        self.id = id
        self.version = version
        self.documentStatus = documentStatus
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case patient
        case activities
        case processId
        case title
        case description
        case responsibleOrganization
        case id
        case version
        case documentStatus
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(patient, forKey: .patient)
        try container.encodeIfPresent(activities, forKey: .activities)
        try container.encodeIfPresent(processId, forKey: .processId)
        try container.encode(title, forKey: .title)
        try container.encodeIfPresent(description, forKey: .description)
        try container.encode(responsibleOrganization, forKey: .responsibleOrganization)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(version, forKey: .version)
        try container.encodeIfPresent(documentStatus, forKey: .documentStatus)
    }
}

